#! /usr/bin/env python
"""VRML97 load-and-view demonstration/test"""
from OpenGLContext.testingcontext import getInteractive
BaseContext, MainFunction = getInteractive()
from OpenGLContext import vrmlcontext
import sys

class TestContext( 
	vrmlcontext.VRMLContext, 
	BaseContext 
):
	"""VRML97-loading Context testing class"""
	def OnInit( self ):
		"""Load the image on initial load of the application"""
		filename = sys.argv[1]
		self.load( filename )
		vrmlcontext.VRMLContext.OnInit( self )
		BaseContext.OnInit( self )
		self.addEventHandler( 
			"keypress", name="c", function = self.OnRecordCallGraph
		)
	recording = False
	def OnRecordCallGraph( self, event ):
		"""Record our callgraph (toggle)"""
		import pycallgraph
		if not self.recording:
			pycallgraph.start_trace()
		else:
			pycallgraph.stop_trace()
			pycallgraph.make_call_graph('test.png')
		self.recording = not self.recording



if __name__ == "__main__":
	usage = """vrml_view.py myscene.wrl

	A very limited VRML97 viewer.
	"""
	import sys
	if not sys.argv[1:2]:
		print usage
		sys.exit(1)
	MainFunction ( TestContext)



