"""VRML97 context for GLUT
"""
from OpenGLContext import glutinteractivecontext
from OpenGLContext import vrmlcontext
import os, glob

class VRMLContext(
	vrmlcontext.VRMLContext,
	glutinteractivecontext.GLUTInteractiveContext
):
	"""GLUT-specific VRML97-aware Testing Context"""
	worldPaths = []
	def createMenus( self ):
		"""Create pop-up menus for the VRML97 context"""
		# get the list of all VRML97 files in our sub-directory
		from OpenGLContext import tests
		from OpenGLContext.tests.resources import test_vrml_set_txt
		base = os.path.join( os.path.dirname( tests.__file__ ), 'wrls', '*.wrl' )
		paths = glob.glob( base )
		fileMenu = glutCreateMenu("File")
		for path in paths:
			self.worldPaths.append( path )
			index = len(self.worldPaths.index( path ))-1
			glutAddMenuEntry(os.path.join( 'wrls',os.path.basename(path)), index)
		urlMenu = glutCreateMenu("URL")
		for path in [ line.strip() for line in test_vrml_set_txt.data.split( '\n')]:
			self.worldPaths.append( path )
			index = len(self.worldPaths.index( path ))-1
			glutAddMenuEntry(path, index)
		loadMenu = glutCreateMenu( "Load" )
		glutAddSubMenu( fileMenu )
		glutAddSubMenu( urlMenu )
		glutAttachMenu(GLUT_MIDDLE_BUTTON)
		return loadMenu

def main( TestContext ):
	"""Mainloop for the GLUT testing context"""
	from OpenGL.GLUT import glutInit, glutMainLoop
	# initialize GLUT windowing system
	import sys
	try:
		glutInit( sys.argv)
	except TypeError:
		import string
		glutInit( string.join(sys.argv, ' '))
	
	render = TestContext()
	if hasattr( render, 'createMenus' ):
		render.createMenus()
	glutMainLoop()

BaseContext = VRMLContext